/* $Id$ */
/*
 * Cantus Tag Editor
 * Copyright © 2002-2004 by Samuel Abels <spam@debain.org>
 * Copyright © 2007 by Tim Huetz <tim.huetz@futures-net.de>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>
 **/

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#ifndef HAVE_LIB_GTKDIRTREE_H
#define HAVE_LIB_GTKDIRTREE_H

#ifdef __cplusplus
extern "C" {
#endif

GtkTreeStore *dirtree_create(GtkWidget *treeview);
void dirtree_expand(GtkTreeModel *model, GtkTreePath *path, gboolean showhidden);
void dirtree_collapse(GtkTreeModel *model, GtkTreePath *path, gboolean keepdummy);
void dirtree_destroy(GtkTreeStore *model);
void dirtree_open_directory(GtkTreeView *treeview, GtkTreeModel *model, const gchar *dir);
const gchar *dirtree_path_get(GtkTreeView *treeview, GtkTreePath *path);
const gchar *dirtree_path_get_selected(GtkTreeView *treeview);

#ifdef __cplusplus
}
#endif

#endif
