/* $Id$ */
/*
 * Cantus Tag Editor
 * Copyright © 2002-2004 by Samuel Abels <spam@debain.org>
 * Copyright © 2007 by Tim Huetz <tim.huetz@futures-net.de>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>
 **/

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#ifndef HAVE_PLUGINAREA_H
#define HAVE_PLUGINAREA_H

#include <iostream>
#include <map>
#include <list>
#include <gtkmm.h>
#include <cantus/plugin.h>


class PluginArea : public Gtk::Notebook {
public:
  PluginArea(gboolean is_vertical);
  ~PluginArea();
  
  /* Triggered whenever a widget has been removed. */
  SigC::Signal1<void, CantusPlugin *> signal_widget_removed;
  
  // Operates on single plugins.
  void      plugin_attach(CantusPlugin *plugin);
  void      plugin_remove(CantusPlugin *plugin);
  gboolean  plugin_is_visible(CantusPlugin *plugin);
  
  // Operates on a list of plugins.
  void      plugins_set(std::list<CantusPlugin*> *plugins);
  void      plugins_attach(std::list<CantusPlugin*> *plugins);
  void      plugins_remove(std::list<CantusPlugin*> *plugins);
  
protected:
  std::map<CantusPlugin*, Gtk::Widget*> visibleplugins;
  gboolean  vertical;  // Whether or not the plugin is shown in vertical pos.
  
  void      remove_unneeded(std::list<CantusPlugin*> *required);
  gboolean  in_list(CantusPlugin *plugin, std::list<CantusPlugin*> *required);
};

#endif
