/* $Id$ */
/*
 * Cantus Tag Editor
 * Copyright © 2002-2004 by Samuel Abels <spam@debain.org>
 * Copyright © 2007 by Tim Huetz <tim.huetz@futures-net.de>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>
 **/

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#ifndef HAVE_DISPLAYAREA_H
#define HAVE_DISPLAYAREA_H

#include <iostream>
#include <gtkmm.h>
#include <libintl.h>
#include <map>
#include <cantus/cantusplugin.h>

#define _(String) gettext (String)
#define gettext_noop(String) (String)
#define N_(String) gettext_noop (String)

using namespace std;
using namespace Gtk;


class Displayarea : public sigc::trackable {
public:
  Displayarea(CantusHash *pplugindata);
  ~Displayarea();
  
  GtkWidget *build(bool vertical);
  
private:
  void on_selection_changed_event(void *pfilenames);
  void on_file_read_finished_event(void *pinfo);
  void on_uiwidget_destroyed_event(void *name);
  
  std::map<string, Label*> widgets;
  std::list<long>  listenerids;     // The ids of the eventbus listeners.
  CantusHash      *plugindata;
  bool             update;
};

#endif
