/* $Id$ */
/*
 * Cantus Tag Editor
 * Copyright © 2002-2004 by Samuel Abels <spam@debain.org>
 * Copyright © 2007 by Tim Huetz <tim.huetz@futures-net.de>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>
 **/

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#ifndef FALSE
#define FALSE 0
#endif
#ifndef TRUE
#define TRUE 1
#endif

#ifndef HAVE_MPEGHEADER_H
#define HAVE_MPEGHEADER_H

#if defined( __cplusplus )
    extern "C" {
#endif

#include <stdio.h>
#include <string.h>

typedef struct {
  char version[30];
  int layer;
  short int protection;
  int bitrate;
  int frequency;
  short int padding;
  short int is_private;
  int mode;
  short int intensity_stereo;
  short int ms_stereo;
  short int copyright;
  short int original;
  int emphasis;
  int frames;
  int seconds;
} MpgHeader;

int get_mpgheader(MpgHeader *header, const char *filename);

#if defined( __cplusplus )
    }
#endif

#endif
