/* $Id$ */
/*
 * Cantus Tag Editor
 * Copyright © 2002-2004 by Samuel Abels <spam@debain.org>
 * Copyright © 2007 by Tim Huetz <tim.huetz@futures-net.de>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>
 **/

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#ifndef HAVE_TAGEDITOR_H
#define HAVE_TAGEDITOR_H

#include <iostream>
#include <gtkmm.h>
#include <libintl.h>
#include <list>
#include <map>
#include <cantus/cantusplugin.h>
#include <cantusplugins/tag2filename/editarea.h>

#define _(String) gettext (String)
#define gettext_noop(String) (String)
#define N_(String) gettext_noop (String)

class Tag2Filename : public sigc::trackable {
public:
  Tag2Filename(CantusHash *pplugindata);
  ~Tag2Filename();
  
  GtkWidget *editarea_build(bool vertical);
  
private:
  void show_first_tag(void);
  void on_selection_changed_event(void *pfilenames);
  void on_file_read_finished_event(void *pinfo);
  void on_filelist_read_finished_event(void *trash);
  std::string tag2filename(CantusHash *info, std::string tag);
  void on_editarea_button_save_clicked(void);
  void on_uiwidget_destroyed_event(void *widget);
  
  Editarea         editarea;
  std::list<const gchar*> fields;         // A list of all tag fields.
  std::list<long>  listenerids;           // The ids of the eventbus listeners.
  GList           *selected;              // A list of all selected files.
  CantusHash      *plugindata;
  bool             isfirst;
  bool             error;                 // Whether the cur. format is invalid.
};

#endif
